#include <SDL.h>
#include <stdlib.h>
#include <math.h>

#include "def.h"
#include "log.h"
#include "log.h"
#include "physics.h"
#include "opengl.h"
#include "ship.h"
#include "pilot.h"

int main(int argc, const char** argv) {
  int quit = 0;
  SDL_Event event;

  gl_screen.w = 800;
  gl_screen.h = 640;
  gl_screen.fullscreen = 0;

  gl_init();

  gl_texture* tex;
  if((tex = gl_newSprite("../gfx/ship.png", 6, 6)) == NULL) {
    WARN("Unable to load image");
    return -1;
  }
  Ship* ship = MALLOC_L(Ship);
  ship->gfx_ship = tex;
  ship->mass = 1;
  ship->class = SHIP_CLASS_CIVILIAN;
  Pilot* player = pilot_create(ship, "player", NULL, NULL, PILOT_PLAYER);
  gl_bindCamera(&player->solid->pos);

  int tflag = 0;
  unsigned int time = SDL_GetTicks();
  FP dt;
  while(!quit) {
    while(SDL_PollEvent(&event)) {
      switch(event.type) {
      case SDL_KEYDOWN:
        switch(event.key.keysym.sym) {
          case SDLK_ESCAPE:
            quit = 1;
            break;
          case SDLK_a:
            tflag ^= 1;
            break;
          case SDLK_d:
            tflag ^=2;
          case SDLK_w:
            tflag ^= 8;
            break;
          default:
            break;  
        }
        break;
      case SDL_KEYUP:
        switch(event.key.keysym.sym) {
          case SDLK_a:
            tflag ^= 1;
            break;
          case SDLK_d:
            tflag ^= 2;
            break;
          case SDLK_w:
            tflag ^= 8;
            break;
          default:
            break;
        }
        break;
      }
    }
    dt = (FP)(SDL_GetTicks() - time) / 1000.0;
    if(tflag & 1) player->solid->dir += 200.0 / 180.0*M_PI*dt;
    if(tflag & 2) player->solid->dir -= 200.0 / 180.0*M_PI*dt;
    if(tflag & 8) player->solid->force = 340;
    else player->solid->force = 0;
    glClear(GL_COLOR_BUFFER_BIT);
    player->update(player, dt);
    SDL_GL_SwapBuffers();
    time = SDL_GetTicks();
    SDL_Delay(5);
  }

  pilot_free(player);
  free(ship);
  gl_free(tex);

  gl_exit();

  return 0;
}

