#pragma once
#include "def.h"

// Base of 2D vectors.
typedef struct {
  FP x, y; // Basic 2D vector components.
} Vec2;

// Describe any solid in 2D space.
struct Solid {
  FP mass, force, dir; // Properties.
  Vec2 vel, pos; // Position/velocity vectors.
  void(*update)(struct Solid*, const FP); // Update method.
};

typedef struct Solid Solid;

void solid_init(Solid* dest, const FP mass, const Vec2* vel, const Vec2* pos);
Solid* solid_create(const FP mass, const Vec2* vel, const Vec2* pos);
void solid_free(Solid* src);

